/* Copyright 2003 TransGaming Technologies */

#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>


/* FIXME: Would be better to not have this duplicated, but we don't have a proper
 *        port library at this point.
 */

#ifdef __linux__

#  if !defined( SYS_tkill ) && defined( __i386__ )
#    define SYS_tkill 238
#  endif

#  if !defined( SYS_gettid ) && defined( __i386__ )
#    define SYS_gettid 224
#  endif

#endif /* __linux__ */

/* Get the id of a thread */
pid_t wine_gettid(void)
{
    pid_t ret;
  
#if defined( __linux__ ) && defined( __i386__ ) /* && defined( USE_PTHREADS ) */

    /* fprintf( stderr, "Attempting linux gettid syscall\n" ); */

    __asm__("int $0x80" : "=a" (ret) : "0" (SYS_gettid));

    if( ret >= 0 ) return ret;
    
    /* fprintf( stderr, "Using fallback for gettid\n" ); */
  
#endif
    
   return getpid();
}

/* Send a signal to a specific thread */
int wine_tkill( pid_t tid, int sig )
{
  int ret;

#if defined( __linux__ ) &&  defined( __i386__ )  /* && defined( USE_PTHREADS ) */

  /* fprintf( stderr, "Attempting linux tkill syscall\n" ); */

  __asm__( "pushl %%ebx\n\t"
           "movl %2,%%ebx\n\t"
           "int $0x80\n\t"
           "popl %%ebx\n\t"
             : "=a" (ret)
             : "0" (SYS_tkill), "r" (tid), "c" (sig) );

  if( ret >= 0 ) return ret;
  
  /* fprintf( stderr, "Invoking fallback for tkill\n" ); */

#endif

  ret = kill( tid, sig );
  
  return ret;
}
